Subject: Re: FVWM: Startup files...

From: Lars Wirzenius <[email-masked]>
Date: Thu, 23 May 1996 21:31:10 +0300

Sherwood Botsford:
> How difficult would it be with fvwm for it to read system.fvwmrc, AND
> ~/.fvwmrc?

I've been hacking together a system.fvwmrc that has enough hooks that
a user or sysadmin can customize it as they wish, but which does not require
modifying the original file.  

A trimmed down version is:

	Read /etc/X11/fvwm2/pre.hook
	Read .fvwm2/pre.hook

	... various settings that can later be overridden ...

	DestroyMenu InitFunction
	AddToFunc InitFunction
	+ "I" Exec /etc/X11/fvwm2/setup-background
	Read /etc/X11/fvwm2/init.hook
	Read /etc/X11/fvwm2/init-restart.hook
	Read .fvwm2/init.hook
	Read .fvwm2/init-restart.hook

	DestroyMenu RestartFunction
	AddToFunc RestartFunction
	Read /etc/X11/fvwm2/restart.hook
	Read /etc/X11/fvwm2/init-restart.hook
	Read .fvwm2/restart.hook
	Read .fvwm2/init-restart.hook

	DestroyMenu MainMenu
	AddToMenu MainMenu
	+ "Main menu"		Title 	
	+ "XTerm"		Exec xterm
	Read /etc/X11/fvwm2/main-menu.hook
	Read .fvwm2/main-menu.hook
	+ ""			Nop
	+ "Exit Fvwm"		Menu Quit-Verify

	... winops/quit-verify menus, mouse and key bindings, functions ...

	Read /etc/X11/fvwm2/post.hook
	Read .fvwm2/post.hook

Notes:

o	most user added stuff is meant to be put into post.hook, except for
	main menu extensions, which go into main-menu.hook

o	every hook is duplicated for both sysadmin and user; user hooks
	override admin hooks

o	setup-background looks for a background.{gif,xpm,jpg,color} file
	and shows it if it finds it (i.e., the user does not have to
	write a command to it, copying the image into .fvwm2 is enough);
	it's a simple shell script, and relies on some external tools
	(xpmroot, xloadimage)
	
o	my admin setup automatically creates a /etc/X11/fvwm2/main-menu.hook 
	that contains Applications and Games submenus, with entries for the
	installed programs (I will try to get Debian Linux developers support
	this, so that each package executes a command to automatically add
	a program to the menus when installed, and removes it when 
	uninstalled); however, this is not part of the basic extensible 
	system.fvwmrc thing under discussion here
	
o	my personal user setup adds CD and Communications submenus

Further ideas:

o	some way to override /etc/X11/fvwm2/main-menu.hook; possibly
	beginning .fvwm2/main-menu.hook with the following might work
	well enough:
	
		DestroyMenu MainMenu
		AddToMenu MainMenu
		+ "XTerm" Exec xterm
		... user's own entries here
		
o	some really simple ways to change colors, background, and some
	other simple configuration stuff, preferably with a GUI interface

Questions:

o	am I correct if I assume that the order in which statements occur
	in config files no longer matter?

o	would it be good if something like it were put into the standard 
	distribution?
	
o	anyone want to test it on real users?

--
Visit the official FVWM web page at <URL:http://www.hpc.uh.edu/fvwm/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].